package edu.wustl.cse.mobilab.openworkflow.comm;

import edu.wustl.cse.mobilab.openworkflow.workflow.TaskNode;

public interface CommProxy {

    FragmentQueryable getFragmentQueryable();
    TaskFeasibilityQueryable getTaskFeasibilityQueryable();
    AuctionQueryable getAuctionQueryable();
    ExecutionDataQueryable getExecutionDataQueryable();

    void addFragmentQueryable(FragmentQueryable fragmentQueryable);
    void addTaskFeasibilityQueryable(TaskFeasibilityQueryable taskFeasibilityQueryable);
    void addAuctionQueryable(AuctionQueryable auctionQueryable);
    void addExecutionDataQueryable(ExecutionDataQueryable executionDataQueryable);
    void subscribeTaskFeasibility(TaskNode taskNode, TaskFeasibilityQueryable.Listener listener);
    void unsubscribeTaskFeasibility(TaskNode taskNode, TaskFeasibilityQueryable.Listener listener);

    void addFragmentObservable(FragmentObservable fragmentObservable);
}
