package edu.wustl.cse.mobilab.openworkflow.comm;

import edu.wustl.cse.mobilab.openworkflow.workflow.ConfigurationNode;

import java.io.Serializable;

public class ConfigurationNodeWrapper implements Serializable {

    private static final long serialVersionUID = 1;

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final ConfigurationNodeWrapper other = (ConfigurationNodeWrapper) obj;
        if (this.m_configurationNode != other.m_configurationNode && (this.m_configurationNode == null || !this.m_configurationNode.equals(other.m_configurationNode))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 19 * hash + (this.m_configurationNode != null ? this.m_configurationNode.hashCode() : 0);
        return hash;
    }
    private ConfigurationNode m_configurationNode;

    public ConfigurationNodeWrapper(ConfigurationNode configurationNode) {
        m_configurationNode = configurationNode;
    }

    public ConfigurationNode getConfigurationNode() {
        return m_configurationNode;
    }


}
