package edu.wustl.cse.mobilab.openworkflow.comm;

import edu.wustl.cse.mobilab.openworkflow.workflow.ExecutionDataName;

//--------------------------------------------------------------------
/** (description of class)
 * @author Created by Louis Thomas on Nov 6, 2008. */
public interface ExecutionDataQueryable {

    // I went with subscribe/unsubscribe rather than a request because
    // we need to be able to cancel the request and the sematics of
    // cancelling a request are less obvious than
    // subscribe/unsubscribe.

    void subscribeData(ExecutionDataName executionDataName, Listener listener);
    void unsubscribeData(ExecutionDataName executionDataName, Listener listener);
    void declareData(ExecutionDataName executionDataName);

    interface Listener {
        void handleData(ExecutionDataName executionDataName, Object data);
    }
}
