package edu.wustl.cse.mobilab.openworkflow.comm;

import edu.wustl.cse.mobilab.openworkflow.verify.Require;

//--------------------------------------------------------------------
/** (description of class)
 * @author Created by Louis Thomas on Feb 16, 2009. */
public class StringHostId implements HostId {

    private final String m_sHostId;

    //----------------------------------------------------------------
    public StringHostId(String sHostId) {
        Require.nonempty(sHostId, "sHostId");
        m_sHostId=sHostId;
    }

    //----------------------------------------------------------------
    @Override
    public boolean equals(Object that) {
        if (this==that) { return true; }
        if (that==null || getClass()!=that.getClass()) { return false; }
        StringHostId stringHostId=(StringHostId)that;
        if (!m_sHostId.equals(stringHostId.m_sHostId)) { return false; }
        return true;
    }

    //----------------------------------------------------------------
    @Override
    public int hashCode() {
        return m_sHostId.hashCode();
    }

    //----------------------------------------------------------------
    @Override
    public String toString() {
        return "{HostId \""+m_sHostId+"\"}";
    }
}
