package edu.wustl.cse.mobilab.openworkflow.schedule;

import edu.wustl.cse.mobilab.openworkflow.verify.Require;

//--------------------------------------------------------------------
/** Default implementation of Duration
 * @author Created by Louis Thomas on Feb 17, 2009. */
public class DurationImpl implements Duration {

    private final long m_nValue;

    //----------------------------------------------------------------
    public DurationImpl(long nValue) {
        m_nValue=nValue;
    }

    //----------------------------------------------------------------
    public long getValue() {
        return m_nValue;
    }

    //----------------------------------------------------------------
    public Duration plus(Duration duration) {
        Require.neqNull(duration, "duration");
        return new DurationImpl(m_nValue+duration.getValue());
    }

    //----------------------------------------------------------------
    public Duration minus(Duration duration) {
        Require.neqNull(duration, "duration");
        return new DurationImpl(m_nValue-duration.getValue());
    }

    //----------------------------------------------------------------
    public int compareTo(Duration rightDuration) {
        Require.neqNull(rightDuration, "rightDuration");
        if (m_nValue<rightDuration.getValue()) {
            return -1;
        } else if (m_nValue>rightDuration.getValue()) {
            return 1;
        }
        return 0;
    }

    //----------------------------------------------------------------
    @Override
    public boolean equals(Object that) {
        if (this==that) { return true; }
        if (that==null || getClass()!=that.getClass()) { return false; }
        DurationImpl duration=(DurationImpl)that;
        if (m_nValue!=duration.m_nValue) { return false; }
        return true;
    }

    //----------------------------------------------------------------
    @Override
    public int hashCode() {
        return (int)(m_nValue^(m_nValue>>>32));
    }

    //----------------------------------------------------------------
    @Override
    public String toString() {
        return "{Duration "+m_nValue+"}";
    }
}
