package edu.wustl.cse.mobilab.openworkflow.schedule;

import edu.wustl.cse.mobilab.openworkflow.service.ServiceDescriptor;
import edu.wustl.cse.mobilab.openworkflow.verify.Require;
import edu.wustl.cse.mobilab.openworkflow.workflow.Task;

//--------------------------------------------------------------------
/** (description of class)
 * @author Created by Louis Thomas on Feb 18, 2009. */
public class ServiceInvocationDescriptor {

    private final ServiceDescriptor m_serviceDescriptor;
    private final Task m_task;

    //----------------------------------------------------------------
    public ServiceInvocationDescriptor(ServiceDescriptor serviceDescriptor, Task task) {
        Require.neqNull(serviceDescriptor, "serviceDescriptor");
        Require.neqNull(task, "task");
        m_serviceDescriptor=serviceDescriptor;
        m_task=task;
    }

    //----------------------------------------------------------------
    public TimePeriod getTimePeriod() {
        return m_task.getTimePeriod();
    }

    //----------------------------------------------------------------
    public Location getLocation() {
        return m_task.getLocation();
    }

    //----------------------------------------------------------------
    public ServiceDescriptor getServiceDescriptor() {
        return m_serviceDescriptor;
    }

    //----------------------------------------------------------------
    public Task getTask() {
        return m_task;
    }

    //----------------------------------------------------------------
    @Override
    public String toString() {
        return "{ServiceInvocationDescriptor "+m_serviceDescriptor+" "+m_task+"}";
    }
}
