package edu.wustl.cse.mobilab.openworkflow.service;

import edu.wustl.cse.mobilab.openworkflow.verify.Require;
import org.jdom.Element;

//--------------------------------------------------------------------
/** (description of class)
 * @author Created by Amanda Ries on Jan 20, 2009. */
public class ServiceDescriptorImpl implements ServiceDescriptor {

    private final String m_sName;
    private final String m_sContract;
    private final String m_sJavaClass;
    private final Element m_configurationData;

    //----------------------------------------------------------------
    public ServiceDescriptorImpl(String sName, String sContract, String sJavaClass, Element configurationData) {
        Require.nonempty(sName, "sName");
        Require.nonempty(sContract, "sContract");
        Require.nonempty(sJavaClass, "sJavaClass");
        m_sName=sName;
        m_sContract=sContract;
        m_sJavaClass=sJavaClass;
        m_configurationData=configurationData;
    }

    //----------------------------------------------------------------
    public String getServiceName() {
        return m_sName;
    }

    //----------------------------------------------------------------
    public String getContract() {
        return m_sContract;
    }

    //----------------------------------------------------------------
    public String getJavaClass() {
        return m_sJavaClass;
    }

    //----------------------------------------------------------------
    public Element getConfigurationData() {
        return m_configurationData;
    }

    //----------------------------------------------------------------
    @Override
    public boolean equals(Object that) {
        if (this==that) { return true; }
        if (that==null || getClass()!=that.getClass()) { return false; }
        ServiceDescriptorImpl serviceNode=(ServiceDescriptorImpl)that;
        if (!m_sContract.equals(serviceNode.m_sContract)) { return false; }
        if (!m_sJavaClass.equals(serviceNode.m_sJavaClass)) { return false; }
        if (!m_sName.equals(serviceNode.m_sName)) { return false; }
        return true;
    }

    //----------------------------------------------------------------
    @Override
    public int hashCode() {
        int result=m_sName.hashCode();
        result=31*result+m_sContract.hashCode();
        result=31*result+m_sJavaClass.hashCode();
        return result;
    }

    //----------------------------------------------------------------
    @Override
    public String toString() {
        return "{ServiceDescriptor name:\""+m_sName+"\" contract:\""+m_sContract+"\" javaClass:"+m_sJavaClass+"}";
    }
}