package edu.wustl.cse.mobilab.openworkflow.service;

import edu.wustl.cse.mobilab.openworkflow.verify.Assert;
import org.apache.log4j.Logger;
import org.jdom.Element;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

//--------------------------------------------------------------------
/** (description of class)
 * @author Created by Amanda Ries on Feb 17, 2009. */
public class SimpleServiceImpl implements SimpleService {

    private static final String NAME_ATTRIBUTE="Name";
    private static final String VALUE_ATTRIBUTE="Value";
    private static final String OUTPUT_NAME="Output";

    public Map<String, Object> invoke(Map<String, Object> arguments) {
        if (arguments.containsKey(ServiceManager.Parameters.LOGGER)) {
            Logger logger=(Logger)arguments.get(ServiceManager.Parameters.LOGGER);
            logger.debug("SimpleServiceImpl: Invoked with argument keys "+arguments.keySet()+".");
        }
        LinkedHashMap<String, Object> outputParametersMap=new LinkedHashMap<String, Object>();
        if (arguments.containsKey(ServiceManager.Parameters.CONFIGURATION_DATA)) {
            Element configurationData=(Element)arguments.get(ServiceManager.Parameters.CONFIGURATION_DATA);
            for (Element childElement : (List<Element>)configurationData.getChildren()) {
                if (OUTPUT_NAME.equals(childElement.getName())) {
                    Assert.neqNull(childElement.getAttribute(NAME_ATTRIBUTE), "childElement.getAttribute(NAME_ATTRIBUTE)");
                    Assert.neqNull(childElement.getAttribute(VALUE_ATTRIBUTE), "childElement.getAttribute(VALUE_ATTRIBUTE)");
                    outputParametersMap.put(childElement.getAttributeValue(NAME_ATTRIBUTE), childElement.getAttributeValue(VALUE_ATTRIBUTE));
                }
            }
        }
        return outputParametersMap;
    }
}
