package edu.wustl.cse.mobilab.openworkflow.service.ui;

import javax.swing.*;
import java.awt.*;
import edu.wustl.cse.mobilab.openworkflow.service.ServiceDescriptor;
import edu.wustl.cse.mobilab.openworkflow.service.ServiceManager;
import edu.wustl.cse.mobilab.openworkflow.shell.ui.TabModel;
import edu.wustl.cse.mobilab.openworkflow.verify.Assert;
import edu.wustl.cse.mobilab.openworkflow.verify.Require;

import java.awt.Color;
import java.awt.Component;

import javax.swing.Box;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

//--------------------------------------------------------------------
/** (description of class)
 * @author Created by Louis Thomas on Feb 19, 2009. */
public class ServicesTab implements TabModel  {

    private final ServiceManager m_serviceManager;

    //----------------------------------------------------------------
    public ServicesTab(ServiceManager serviceManager) {
        Require.neqNull(serviceManager, "serviceManager");
        m_serviceManager=serviceManager;
    }

    //----------------------------------------------------------------
    // from TabModel
    public String getName() {
        return "Services";
    }

    //----------------------------------------------------------------
    // from TabModel
    public Component getComponent() {
        JPanel p = new JPanel(new BorderLayout());
        JPanel test = new JPanel();
        test.setLayout(new BoxLayout(test, BoxLayout.Y_AXIS));
        test.setBackground(Color.white);
        test.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
       
        JPanel serv1 = new JPanel();
        serv1.setBackground(Color.BLACK);
       
        JPanel serv2 = new JPanel();
        serv2.setBackground(Color.green);
        JPanel serv3 = new JPanel();
        serv3.setBackground(Color.yellow);
        
        test.add(serv1);
        test.add(Box.createVerticalStrut(10));
        
        test.add(serv2);
        test.add(Box.createVerticalStrut(10));
        test.add(serv3);
        
        p.add(new JLabel("SERVICES"), BorderLayout.NORTH);
        p.add(new JScrollPane(test), BorderLayout.CENTER);
        p.add(new JButton("CREATE.."), BorderLayout.SOUTH);
        
        p.setBackground(Color.red);
        return p;
    }

    //----------------------------------------------------------------
    private void subscribe() {
        m_serviceManager.subscribeServiceDescriptors(new ServiceManager.ServiceDescriptorListener() {
            public void updateServiceDescriptor(final ServiceDescriptor oldServiceDescriptor, final ServiceDescriptor newServiceDescriptor) {
                // this method is called on the sustem thread, we need to process it on the GUI thread
                // use invokeLater to hand off to the GUI thread
                SwingUtilities.invokeLater(new Runnable() {
                    public void run() {
                        ServicesTab.this.updateServiceDescriptor(oldServiceDescriptor, newServiceDescriptor);
                    }
                });
            }
        });
    }

    //----------------------------------------------------------------
    private void updateServiceDescriptor(ServiceDescriptor oldServiceDescriptor, ServiceDescriptor newServiceDescriptor) {
        // update the model with the changed service descriptor

    }
}
