package edu.wustl.cse.mobilab.openworkflow.shell;

import edu.wustl.cse.mobilab.openworkflow.verify.Require;
import org.jdom.Element;

//--------------------------------------------------------------------
/** (description of class)
 * @author Created by Louis Thomas on Nov 6, 2008. */
public interface PersistenceProvider {

    Element loadXmlByName(String sName) throws NameNotFoundException;
    void saveXmlByName(String sName, Element rootElement);

    //----------------------------------------------------------------
    class NameNotFoundException extends Exception {
        private static final long serialVersionUID = 1;
        private final String m_sName;
        
        public NameNotFoundException(String sName) {
            super("Name \""+sName+"\" not found.");
            Require.nonempty(sName, "sName");
            m_sName=sName;
        }

        public String getName() {
            return m_sName;
        }
    }
}
