package edu.wustl.cse.mobilab.openworkflow.util;

//--------------------------------------------------------------------
/** (description of class)
* @author Created by Louis Thomas on Feb 2, 2009. */
public class FatalUncaughtExceptionHandler implements Thread.UncaughtExceptionHandler {

    /** See {@link java.awt.EventDispatchThread#handleException(Throwable)}*/
    private static final String MODAL_DIALOG_UNCAUGHT_EXCEPTION_HANDLER_PROPERTY="sun.awt.exception.handler";

    //------------------------------------------------------------
    public static void register() {
        System.setProperty(MODAL_DIALOG_UNCAUGHT_EXCEPTION_HANDLER_PROPERTY, FatalUncaughtExceptionHandler.class.getName());
        Thread.setDefaultUncaughtExceptionHandler(new FatalUncaughtExceptionHandler());
    }

    //------------------------------------------------------------
    // for AWT modal dialogs
    public void handle(Throwable e) {
        uncaughtException(Thread.currentThread(), e);
    }

    //------------------------------------------------------------
    // from Thread.UncaughtExceptionHandler
    public void uncaughtException(Thread t, Throwable e) {
        System.err.println("Uncaught exception in thread "+t+".");
        //noinspection CallToPrintStackTrace
        e.printStackTrace();
        Runtime.getRuntime().halt(0);
    }
}
