package edu.wustl.cse.mobilab.openworkflow.util;

import edu.wustl.cse.mobilab.openworkflow.verify.Require;

import java.io.Serializable;

//--------------------------------------------------------------------
/** Binds a {@link ReplyStatus} and a reply detail together for
 * convenience.
* @author Created by Louis Thomas on Oct 12, 2007. */
public class ReplyInfo<SuccessType> implements Serializable {

    private static final long serialVersionUID=8602289085645444031L;

    private final ReplyStatus m_replyStatus;
    private final Object m_replyDetail;

    public ReplyInfo(ReplyStatus replyStatus, Object replyDetail) {
        Require.neqNull(replyStatus, "replyStatus");
        m_replyStatus=replyStatus;
        m_replyDetail=replyDetail;
    }

    public ReplyStatus getReplyStatus() {
        return m_replyStatus;
    }

    public Object getReplyDetail() {
        return m_replyDetail;
    }

    @Override
    public String toString() {
        return m_replyStatus.formatWithDetail(m_replyDetail);
    }
}
