package edu.wustl.cse.mobilab.openworkflow.util;

import edu.wustl.cse.mobilab.openworkflow.verify.Require;

//--------------------------------------------------------------------
/** Binds a {@link ReplyListener} and its extra data.
* @author Created by Louis Thomas on Apr 25, 2006 */
public class ReplyListenerInfo<SuccessType> {

    private final ReplyListener<SuccessType> m_replyListener;
    private final Object m_extra;

    //----------------------------------------------------------------
    public ReplyListenerInfo(ReplyListener<SuccessType> replyListener, Object extra) {
        Require.neqNull(replyListener, "replyListener");
        m_replyListener=replyListener;
        m_extra=extra;
    }

    //----------------------------------------------------------------
    public ReplyListener<SuccessType> getReplyListener() {
        return m_replyListener;
    }

    //----------------------------------------------------------------
    public Object getExtra() {
        return m_extra;
    }

    //----------------------------------------------------------------
    public void replyNotification(ReplyStatus replyStatus, Object replyDetail) {
        Require.neqNull(replyStatus, "replyStatus");
        m_replyListener.replyNotification(replyStatus, replyDetail, m_extra);
    }

    //----------------------------------------------------------------
    public void replyNotification(ReplyInfo<SuccessType> replyInfo) {
        Require.neqNull(replyInfo, "replyInfo");
        m_replyListener.replyNotification(replyInfo.getReplyStatus(), replyInfo.getReplyDetail(), m_extra);
    }
}
