package edu.wustl.cse.mobilab.openworkflow.util;

//--------------------------------------------------------------------
/** Status values for use with {@link ReplyListener}.
 * @author Created by Louis Thomas on Apr 25, 2006 */
public enum ReplyStatus {
    /** Indicates that the request was successful. */
    SUCCEEDED,
    /** Indicates that the request failed. In contrast with
     * {@link #DISCONNECTED}, this value indicates that the request
     * was received, considered, and explicitly denied for some
     * reason. */
    DENIED,
    /** Indicates that there was a communcation failure with the
     * intended recipient of the request, either because the recipient
     * was unreachable or the connection was broken before the reply
     * could be received. It is possible that the request was
     * successfully processed (it is impossible to tell), however in
     * most cases this value can be treated the same as any other
     * failure. */
    DISCONNECTED;

    /** Formats a string in the form "status [(detail)]" - for
     * example, "SUCCEEDED" or "DENIED (exception message)". */
    public String formatWithDetail(Object replyDetail) {
        return this+(null==replyDetail?"":" ("+replyDetail+")");
    }
}
