package edu.wustl.cse.mobilab.openworkflow.util;

//--------------------------------------------------------------------
/** Generic tuple. 
 * <P> Note: So far, every time I have used this class, I
 * have ended up creating a real object instead. Nevertheless, this
 * class provides a useful stepping stone during the design
 * process. :)
 * @author Created by Louis Thomas on Oct 27, 2006 */
public class Tuple2<A, B> {
    private final A m_a;
    private final B m_b;

    public Tuple2(A a, B b) {
        m_a=a;
        m_b=b;
    }

    public A getA() {
        return m_a;
    }

    public B getB() {
        return m_b;
    }

    @Override
    public boolean equals(Object that) {
        if (this==that) { return true; }
        if (!(that instanceof Tuple2)) { return false; }

        Tuple2<?,?> tuple2=(Tuple2<?, ?>)that;
        if (m_a!=null?!m_a.equals(tuple2.m_a):tuple2.m_a!=null) { return false; }
        return !(m_b!=null?!m_b.equals(tuple2.m_b):tuple2.m_b!=null);

    }

    @Override
    public int hashCode() {
        int result=(m_a!=null?m_a.hashCode():0);
        result=29*result+(m_b!=null?m_b.hashCode():0);
        return result;
    }

    @Override
    public String toString() {
        return "<"+m_a+","+m_b+">";
    }
}
