package edu.wustl.cse.mobilab.openworkflow.util;

import edu.wustl.cse.mobilab.openworkflow.verify.Assert;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;

//--------------------------------------------------------------------
/** Helpful methods for dealing with XML.
 * @author Created by Louis Thomas on Jan 20, 2009. */
public class XmlUtil {

    //----------------------------------------------------------------
    public static String getElementAsXmlString(Element element) throws IOException {
        StringWriter stringWriter=new StringWriter();
        new XMLOutputter(Format.getCompactFormat()).output(element, stringWriter);
        return stringWriter.toString();
    }

    //----------------------------------------------------------------
    public static Element xmlStringToElement(String sXml) {
        try {
            return new SAXBuilder().build(new StringReader(sXml)).getRootElement();
        } catch (JDOMException e) {
            throw Assert.exceptionNeverCaught(e);
        } catch (IOException e) {
            throw Assert.exceptionNeverCaught(e);
        }
    }
}
