package edu.wustl.cse.mobilab.openworkflow.workflow;

import edu.wustl.cse.mobilab.openworkflow.verify.Require;

import java.io.Serializable;
import java.util.Collections;
import java.util.LinkedHashSet;
import java.util.Set;

//--------------------------------------------------------------------
/** Default implementation of {@link CompositeWorkflowBuilder}.
 * @author Created by Louis Thomas on Dec 3, 2008. */
public class CompositeWorkflowBuilderImpl implements CompositeWorkflowBuilder, Serializable {

    private static final long serialVersionUID = 1;
    private final Set<TaskNode> m_taskNodes=new LinkedHashSet<TaskNode>();

    //----------------------------------------------------------------
    public boolean addTaskNode(TaskNode taskNode) {
        Require.neqNull(taskNode, "taskNode");
        return m_taskNodes.add(taskNode);
    }

    //----------------------------------------------------------------
    public Set<TaskNode> getTaskNodes() {
        return Collections.unmodifiableSet(m_taskNodes);
    }

    //----------------------------------------------------------------
    @Override
    public String toString() {
        return "{CompositeWorkflowBuilder "+m_taskNodes+"}";
    }
}
