package edu.wustl.cse.mobilab.openworkflow.workflow;

import edu.wustl.cse.mobilab.openworkflow.verify.Require;

//--------------------------------------------------------------------
/** Default implementation of {@link ConfigurationNode}.
 * @author Created by Louis Thomas on Nov 6, 2008. */
public class ConfigurationNodeImpl implements ConfigurationNode {

    private static final long serialVersionUID = 1;
    private final String m_sPredicateLabel;

    //----------------------------------------------------------------
    public ConfigurationNodeImpl(String sPredicateLabel) {
        Require.nonempty(sPredicateLabel, "sPredicateLabel");
        m_sPredicateLabel=sPredicateLabel;
    }

    //----------------------------------------------------------------
    @Override
    public boolean equals(Object that) {
        if (this==that) { return true; }
        if (that==null || getClass()!=that.getClass()) { return false; }
        ConfigurationNodeImpl labelNode=(ConfigurationNodeImpl)that;
        if (!m_sPredicateLabel.equals(labelNode.m_sPredicateLabel)) { return false; }
        return true;
    }

    //----------------------------------------------------------------
    @Override
    public int hashCode() {
        return m_sPredicateLabel.hashCode();
    }

    //----------------------------------------------------------------
    @Override
    public String toString() {
        return "{ConfigurationNode predicateLabel:\""+m_sPredicateLabel+"\"}";
    }

    //----------------------------------------------------------------
    public Junction getJunction() {
        return Junction.DISJUNCT;
    }

    //----------------------------------------------------------------
    public String getPredicateLabel() {
        return m_sPredicateLabel;
    }
}
