package edu.wustl.cse.mobilab.openworkflow.workflow;

import edu.wustl.cse.mobilab.openworkflow.verify.Require;

//--------------------------------------------------------------------
/** Default implementation of {@link ExecutionDataName}.
 * @author Created by Amanda Ries on Feb 20, 2009. */
public class ExecutionDataNameImpl implements ExecutionDataName {

    private String m_sName;

    //----------------------------------------------------------------
    public ExecutionDataNameImpl(String sName) {
        Require.nonempty(sName, "sName");
        m_sName=sName;
    }

    //----------------------------------------------------------------
    @Override
    public boolean equals(Object that) {
        if (this==that) { return true; }
        if (that==null || getClass()!=that.getClass()) { return false; }
        ExecutionDataNameImpl subscriptionName=(ExecutionDataNameImpl)that;
        if (!m_sName.equals(subscriptionName.m_sName)) { return false; }
        return true;
    }

    //----------------------------------------------------------------
    @Override
    public int hashCode() {
        return m_sName.hashCode();
    }

    //----------------------------------------------------------------
    @Override
    public String toString() {
        return "{ExecutionDataName \""+m_sName+"\"}";
    }
}