package edu.wustl.cse.mobilab.openworkflow.workflow;

import edu.wustl.cse.mobilab.openworkflow.verify.Require;

//--------------------------------------------------------------------
/** Default implementation of {@link ParameterName}.
 * @author Created by Amanda Ries on Feb 20, 2009. */
public class ParameterNameImpl implements ParameterName {

    private String m_sName;

    //----------------------------------------------------------------
    public ParameterNameImpl(String sName) {
        Require.nonempty(sName, "sName");
        m_sName=sName;
    }

    //----------------------------------------------------------------
    public String getName() {
        return m_sName;
    }

    //----------------------------------------------------------------
    @Override
    public boolean equals(Object that) {
        if (this==that) { return true; }
        if (that==null || getClass()!=that.getClass()) { return false; }
        ParameterNameImpl parameterName=(ParameterNameImpl)that;
        if (!m_sName.equals(parameterName.m_sName)) { return false; }
        return true;
    }

    //----------------------------------------------------------------
    @Override
    public int hashCode() {
        return m_sName.hashCode();
    }

    //----------------------------------------------------------------
    @Override
    public String toString() {
        return "{ParameterName \""+m_sName+"\"}";
    }
}