package edu.wustl.cse.mobilab.openworkflow.workflow;

import edu.wustl.cse.mobilab.openworkflow.util.CollectionUtil;
import edu.wustl.cse.mobilab.openworkflow.verify.Require;

import java.util.LinkedHashSet;
import java.util.Set;

//--------------------------------------------------------------------
/** (description of class)
 * @author Created by Louis Thomas on Jan 15, 2009. */
public class SetAlphaFunction implements AlphaFunction {

    private Set<ConfigurationNode> m_initialConfigurationNodes;

    //----------------------------------------------------------------
    public SetAlphaFunction(Set<ConfigurationNode> initialConfigurationNodes) {
        Require.neqNull(initialConfigurationNodes, "initialConfigurationNodes");
        m_initialConfigurationNodes=new LinkedHashSet<ConfigurationNode>(initialConfigurationNodes);
    }

    //----------------------------------------------------------------
    public boolean isInitialConfiguration(ConfigurationNode configurationNode) {
        Require.neqNull(configurationNode, "configurationNode");
        return m_initialConfigurationNodes.contains(configurationNode);
    }

    //----------------------------------------------------------------
    @Override
    public String toString() {
        return "{SetAlphaFunction "+CollectionUtil.formatSetStringSorted(m_initialConfigurationNodes)+"}";
    }
}
