package edu.wustl.cse.mobilab.openworkflow.workflow;

import java.util.Set;

//--------------------------------------------------------------------
/** Represents a task in a workflow. Tasks are the same only if their
 * preconditions, postconditions, and contract label are the same.
 * <P> Note that the set of attributes that are used for identifying
 * a matching service must be the same as the set of attributes used
 * to determine task identity.
 * @author Created by Louis Thomas on Nov 6, 2008. */
public interface TaskNode extends Node {

    /** Returns the contract label for this task. This is a
     * placeholder for a more complex representation of the
     * tasks's contract.*/
    String getContractLabel();

    /** Returns an unmodifiable, nonempty set. */
    Set<ConfigurationNode> getPreconditions();

    /** Returns an unmodifiable, nonempty set. */
    Set<ConfigurationNode> getPostconditions();
}
