package edu.wustl.cse.mobilab.openworkflow.comm;

import edu.wustl.cse.mobilab.openworkflow.util.RecordingMockObject;
import edu.wustl.cse.mobilab.openworkflow.workflow.ConfigurationNode;

//--------------------------------------------------------------------
/** Mock object for {@link FragmentQueryable}.
* @author Created by Louis Thomas on Jan 15, 2009. */
public class MockFragmentQueryable extends RecordingMockObject implements FragmentQueryable {

    private Listener m_lastListener;

    //----------------------------------------------------------------
    public void subscribeFragmentsWithConfiguration(ConfigurationNode configurationNode, Listener listener) {
        m_lastListener=listener;
        recordActivity("subscribeFragmentsWithConfiguration("+configurationNode+",listener)");
    }

    //----------------------------------------------------------------
    public void unsubscribeFragmentsWithConfiguration(ConfigurationNode configurationNode, Listener listener) {
        recordActivity("unsubscribeFragmentsWithConfiguration("+configurationNode+",listener)");
    }

    //----------------------------------------------------------------
    public Listener getLastListener() {
        return m_lastListener;
    }
}
