package edu.wustl.cse.mobilab.openworkflow.workflow;

import edu.wustl.cse.mobilab.openworkflow.util.BaseTestCase;
import edu.wustl.cse.mobilab.openworkflow.util.CollectionUtil;

//--------------------------------------------------------------------
/** Tests for {@link CompositeWorkflowBuilderImpl}
 * @author Created by Louis Thomas on Dec 3, 2008. */
public class TestCompositeWorkflowBuilderImpl extends BaseTestCase {

    //----------------------------------------------------------------
    public void testAddTaskNode() {

        ConfigurationNode configurationNodeA=new ConfigurationNodeImpl("A");
        ConfigurationNode configurationNodeB=new ConfigurationNodeImpl("B");
        TaskNode taskNode=new TaskNodeImpl("ContractLabel", Junction.DISJUNCT, CollectionUtil.setFromArray(configurationNodeA), CollectionUtil.setFromArray(configurationNodeB));

        CompositeWorkflowBuilder compositeWorkflowBuilder=new CompositeWorkflowBuilderImpl();
        assertCollectionContainsExactly(compositeWorkflowBuilder.getTaskNodes());

        boolean bWasAdded=compositeWorkflowBuilder.addTaskNode(taskNode);
        assertTrue(bWasAdded);
        assertCollectionContainsExactly(compositeWorkflowBuilder.getTaskNodes(), taskNode);

        bWasAdded=compositeWorkflowBuilder.addTaskNode(taskNode);
        assertFalse(bWasAdded);
        assertCollectionContainsExactly(compositeWorkflowBuilder.getTaskNodes(), taskNode);
    }
}