package edu.wustl.cse.mobilab.openworkflow.workflow;

import edu.wustl.cse.mobilab.openworkflow.util.BaseTestCase;
import edu.wustl.cse.mobilab.openworkflow.util.CollectionUtil;

//--------------------------------------------------------------------
/** Tests for {@link TaskNodeImpl}
 * @author Created by Louis Thomas on Dec 2, 2008. */
public class TestTaskNodeImpl extends BaseTestCase {

    //----------------------------------------------------------------
    public void testTaskNodeImpl() {
        ConfigurationNode configurationNodeA=new ConfigurationNodeImpl("A");
        ConfigurationNode configurationNodeB=new ConfigurationNodeImpl("B");
        ConfigurationNode configurationNodeC=new ConfigurationNodeImpl("C");
        ConfigurationNode configurationNodeD=new ConfigurationNodeImpl("D");

        TaskNode taskNode=new TaskNodeImpl("contractLabel", Junction.CONJUNCT, CollectionUtil.setFromArray(configurationNodeA, configurationNodeB), CollectionUtil.setFromArray(configurationNodeC, configurationNodeD));
        assertEquals("contractLabel", taskNode.getContractLabel());
        assertEquals(Junction.CONJUNCT, taskNode.getJunction());
        assertCollectionContainsExactly(taskNode.getPreconditions(), configurationNodeA, configurationNodeB);
        assertCollectionContainsExactly(taskNode.getPostconditions(), configurationNodeC, configurationNodeD);
        assertEquals("{TaskNode contractLabel:\"contractLabel\" junction:CONJUNCT precondition:[{ConfigurationNode predicateLabel:\"A\"}, {ConfigurationNode predicateLabel:\"B\"}] postcondition:[{ConfigurationNode predicateLabel:\"C\"}, {ConfigurationNode predicateLabel:\"D\"}]}", taskNode.toString());

        TaskNode taskNode2=new TaskNodeImpl("contractLabel", Junction.CONJUNCT, CollectionUtil.setFromArray(configurationNodeA, configurationNodeB), CollectionUtil.setFromArray(configurationNodeC, configurationNodeD));
        assertEquals(taskNode, taskNode2);

        TaskNode taskNode3=new TaskNodeImpl("contractLabel2", Junction.CONJUNCT, CollectionUtil.setFromArray(configurationNodeA, configurationNodeB), CollectionUtil.setFromArray(configurationNodeC, configurationNodeD));
        assertFalse(taskNode.equals(taskNode3));

        TaskNode taskNode4=new TaskNodeImpl("contractLabel", Junction.DISJUNCT, CollectionUtil.setFromArray(configurationNodeA, configurationNodeB), CollectionUtil.setFromArray(configurationNodeC, configurationNodeD));
        assertFalse(taskNode.equals(taskNode4));

        TaskNode taskNode5=new TaskNodeImpl("contractLabel", Junction.CONJUNCT, CollectionUtil.setFromArray(configurationNodeB), CollectionUtil.setFromArray(configurationNodeC, configurationNodeD));
        assertFalse(taskNode.equals(taskNode5));

        TaskNode taskNode6=new TaskNodeImpl("contractLabel", Junction.CONJUNCT, CollectionUtil.setFromArray(configurationNodeA, configurationNodeB), CollectionUtil.setFromArray(configurationNodeC));
        assertFalse(taskNode.equals(taskNode6));
    }
}